/*
	\file	HelloWorld.c

	\brief	忰 ̧

	(c) 2020 Microchip Technology Inc.Ǝq

	̏̏ƂāAMicrochipĳƉ̔hMicrochipi
	ɌĎgp邱Ƃł܂BMicrochipĳ𔺂Ȃ(J 
	ĳ܂)Oҿĳ̎gpɓKpO҂̋炷̂͂
	̐ӔCłB

	̿ĳMicrochip"󂻂̂܂"ɂċ܂BNQAiA
	ړIւ̓K̂ǂ̈Öق̕ۏ؂܂߁AIAÎI܂͖@߂ł낤
	̿ĳɂ͓Kp܂B

	ႦMicrochip\iꂽAQ\
	ƂĂA̔@Ɋւ炸A@ȂꍇłMicrochipͿĳɊ֘A
	@Ȃނ̊ԐړIAʁAIAI܂͕KRIȑAQA
	p܂͎x̐ӔC𕉂܂B@ɂċő͈̔͂܂ŁA
	ĳɊ֘Aǂ̕@ł̑SɉĂAmicrochip̑ӔCźA
	΁AȂ̿ĳɑ΂Microchip֒ڎxp̊z𒴂܂B
*/

#include <stdio.h>
#include <stdint.h>
#include <time.h>
#include <ioavr.h>
#include <pgmspace.h>
#include <intrinsics.h>

#define F_CPU (3333333)
#define BOUNCE_TIME (200)
#define NUMBER_OF_LED_STATES (2)
#define MAX_LENGTH_OF_A_LED_STATE_MESSAGE (13)
#define USART3_BAUD_RATE(BAUD_RATE) ((float)(F_CPU * 64 / (16 * (float)BAUD_RATE)) + 0.5)
#define delay_ms(millisecs) __delay_cycles((F_CPU/1000) * (millisecs))

/*
EEPROMɕۑϐ͔Cӂŕۑڽw肷邱Ƃł܂B
̕ϐƂlɂ邱Ƃł܂B
*/
uint8_t __eeprom level @ 0x1400;

/* 
ׯ ؂ɕۑ萔Bׯ̕ƋɓʂȊ֐pgmspace.hŒ`
܂B
*/
const char __flash led_state[NUMBER_OF_LED_STATES][MAX_LENGTH_OF_A_LED_STATE_MESSAGE] = { "LED is on\r\n", "LED is off\r\n" };

/*
1܂͑̊荞޸w肷ɂ#pragma޸^߂gĂB
__interrupt-ܰނ͊荞݊֐w肵܂B
*/
#pragma vector = PORTF_PORT_vect
__interrupt void PORTF_int(void)
{
	if(PORTF.INTFLAGS & PIN6_bm) 
	{
		PORTF.INTFLAGS &= PIN6_bm;
	}
}

/*
USARTւprintfo͂wʊ֐
*/
size_t __write(int handle, const unsigned char *buf, size_t bufSize) 
{
	size_t nChars = 0;
	for (/*  */; bufSize > 0; --bufSize)
	{
		while (!(USART3.STATUS & USART_DREIF_bm))
		{
			;
		}
		USART3.TXDATAL = *buf;
		++buf;
		++nChars;
	}

	return nChars;
}

static void initSleepMode(void) 
{
	SLPCTRL.CTRLA |= SLPCTRL_SEN_bm | SLPCTRL_SMODE_STDBY_gc;
}

static void initUsart(void)
{
	PORTB.DIRSET = PIN0_bm;
	USART3.BAUD = (uint16_t)USART3_BAUD_RATE(9600);
	USART3.CTRLB |= USART_TXEN_bm;
}

static void initLed(void)
{
	PORTF.DIRSET = PIN5_bm;
}

static void initButton(void)
{
	PORTF.DIRCLR = PIN6_bm;
	PORTF.PIN6CTRL |= PORT_PULLUPEN_bm | PORT_ISC_FALLING_gc;
}

int main(void)
{
	initSleepMode();
	initUsart();
	initLed();
	initButton();
	__enable_interrupt();

	if(0 == level)
	{
		PORTF.OUTSET = PIN5_bm;
	}
	else if (1 == level)
	{
		PORTF.OUTCLR = PIN5_bm;
	}
	else
	{
		level = 0;
		PORTF.OUTSET = PIN5_bm;
	}

	__sleep();

	while(1)
	{
		delay_ms(BOUNCE_TIME);

		if(0 == level)
		{
			level = 1;
			PORTF.OUTCLR = PIN5_bm;
		}
		else if (1 == level)
		{
			level = 0;
			PORTF.OUTSET = PIN5_bm;
		}

		printf_P(led_state[level]);

		/*
		x~֍sOUSARTړڼ޽̑Sްړo͂܂őҋ@
		̌Ɏ蓮׸ނ(0)
		*/
		while((!(USART3.STATUS & USART_TXCIF_bm)))
		{
			;
		}
		USART3.STATUS = USART_TXCIF_bm;

		__sleep();
	}
}
